<template>
  <div>
    <v-card>
      <v-toolbar color="grey" dark>
        <v-toolbar-title class="white--text">
          LISTA DE GRÁFICAS
          <v-tooltip bottom>
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                fab
                class="white--text"
                color="primary"
                bottom
                right
                v-bind="attrs"
                v-on="on"
                absolute
                :to="{
                  name: 'sistema_informacion_dashboard_v2_graficas_nueva',
                }"
              >
                <v-icon>mdi-plus</v-icon>
              </v-btn>
            </template>
            <span>Nueva gráfica</span>
          </v-tooltip>
        </v-toolbar-title>
        <v-spacer></v-spacer>
        <v-text-field
          v-model="search"
          label="Buscar"
          flat
          class="mr-16"
          dark
          solo-inverted
          append-icon="mdi-magnify"
          hide-details
          clear-icon="mdi-close-circle-outline"
        ></v-text-field>
      </v-toolbar>
      <v-list three-line subheader>
        <v-subheader>
          <v-badge
            color="grey"
            dark
            inline
            :value="searchResult.length"
            :content="searchResult.length"
          >
            <span class="pt-2">GRÁFICAS</span>
          </v-badge>
        </v-subheader>
        <v-list-item-group
          v-model="selectedItem"
          style="overflow: auto;max-height:500px; min-height:500px"
          color="primary"
        >
          <v-divider />
          <template v-for="(item, indexItem) in searchResult">
            <v-list-item three-line :key="indexItem" link>
              <v-list-item-avatar>
                <v-icon color="grey lighten-1" x-large>mdi-chart-bar</v-icon>
              </v-list-item-avatar>
              <v-list-item-content>
                <v-list-item-subtitle>
                  {{ item.clave }}
                </v-list-item-subtitle>
                <v-list-item-title>
                  <router-link
                    class="text-decoration-underline"
                    :to="toEditGrafica(item)"
                  >
                    {{ item.descripcion }}
                  </router-link>
                </v-list-item-title>
                <v-list-item-subtitle>
                  <v-badge
                    color="primary"
                    inline
                    overlap
                    :value="item.totalSemaforos"
                    :content="item.totalSemaforos"
                  >
                    <v-icon color="grey lighten-1">
                      mdi-traffic-light
                    </v-icon>
                    <router-link
                      class="text-decoration-underline"
                      :to="toGraficaSemaforos(item)"
                    >
                      Semáforos
                    </router-link>
                  </v-badge>
                </v-list-item-subtitle>
              </v-list-item-content>
              <v-list-item-action>
                <v-tooltip bottom>
                  <template v-slot:activator="{ on, attrs }">
                    <v-btn
                      class="white--text"
                      v-bind="attrs"
                      v-on="on"
                      fab
                      small
                      color="primary"
                      @click="deleteItemGrafica(indexItem, item)"
                    >
                      <v-icon>mdi-delete</v-icon>
                    </v-btn>
                  </template>
                  <span>Borrar gráfica</span>
                </v-tooltip>
              </v-list-item-action>
            </v-list-item>
            <v-divider :key="'divider-' + indexItem" />
          </template>
        </v-list-item-group>
      </v-list>
    </v-card>
    <template>
      <v-dialog v-model="isDialogDeleteGrafica" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <strong>¡Oh oh...! </strong>
            Eliminar gráfica. Estas totalmente seguro?
            <v-icon right color="orange">mdi-alert</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <p v-if="editedItemGrafica.descripcion">
              Para confirmar esta acción por favor escribe:
              <br />
              <em
                ><code>{{ editedItemGrafica.descripcion }}</code></em
              >
            </p>
            <v-text-field
              v-model="confirmTextGrafica"
              :autofocus="true"
              label="Confirma con el descripción del gráfica"
              flat
              class="mr-2 ml-2"
            />
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="closeDeleteGrafica"
                >No, cancelar</v-btn
              >
              <v-btn
                :class="[
                  {
                    desac: !(
                      editedItemGrafica.descripcion &&
                      confirmTextGrafica == editedItemGrafica.descripcion
                    ),
                  },
                ]"
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="deleteGrafica"
                >Si, continuar</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
  </div>
</template>
<script>
import store from "@/store";
const serviceCommons = store.state.serviceCommons;
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-ListaGraficas",
  data: (vm) => ({
    data: [],
    isDialogDeleteGrafica: false,
    loading: false,
    caseSensitive: false,
    search: null,
    selectedItem: null,
    editedItemGrafica: {
      descripcion: null,
    },
    defaultEditedItemGrafica: {
      descripcion: null,
    },
    indexItemGrafica: null,
    confirmTextGrafica: null,
  }),
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    searchResult() {
      let tempData = this.data;
      if (this.search != "" && this.search) {
        tempData = tempData.filter((item) => {
          return item.descripcion
            .toUpperCase()
            .includes(this.search.toUpperCase());
        });
      }
      if (tempData.length > 0) {
        tempData = tempData.sort((a, b) => {
          let fa = a.descripcion.toLowerCase();
          let fb = b.descripcion.toLowerCase();
          if (fa < fb) {
            return -1;
          }
          if (fa > fb) {
            return 1;
          }
          return 0;
        });
      }
      return tempData;
    },
  },
  methods: {
    toEditGrafica(grafica) {
      return {
        name: "sistema_informacion_dashboard_v2_graficas_edicion",
        params: {
          grafica: this.serviceCommons.objectToBase64(grafica),
        },
      };
    },
    toGraficaSemaforos(grafica) {
      return {
        name: "sistema_informacion_dashboard_v2_graficas_edicion",
        params: {
          grafica: this.serviceCommons.objectToBase64(grafica),
        },
        query: {
          semaforos: this.serviceCommons.objectToBase64({}),
        },
      };
    },
    deleteGrafica() {
      let grafica = this.editedItemGrafica;
      let indexItem = this.indexItemGrafica;
      axios
        .delete("/sistema-informacion/tablero/graficas/v1/" + grafica.idGrafica)
        .then((response) => {
          this.data.splice(indexItem, 1);
          this.closeDeleteGrafica();
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    deleteItemGrafica(indexItem, item) {
      this.editedItemGrafica = item;
      this.indexItemGrafica = indexItem;
      this.isDialogDeleteGrafica = true;
    },
    closeDeleteGrafica() {
      this.isDialogDeleteGrafica = false;
      this.$nextTick(() => {
        this.editedItemGrafica = Object.assign(
          {},
          this.defaultEditedItemGrafica
        );
        this.indexItemGrafica = -1;
        this.confirmTextGrafica = null;
      });
    },
    getSemaforosGrafica(grafica) {
      axios(
        "/sistema-informacion/tablero/graficas/v1/" +
          grafica.idGrafica +
          "/semaforos"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            grafica.totalSemaforos = data.resultado.semaforos.length;
          }
        })
        .catch((error) => {});
    },
    getGraficas() {
      const self = this;
      this.loading = true;
      axios("/sistema-informacion/tablero/graficas/v1/")
        .then((response) => {
          let data = response.data;
          if (data) {
            data.resultado.graficas = data.resultado.graficas.map((grafica) => {
              grafica.totalSemaforos = null;
              return grafica;
            });
            this.data = data.resultado.graficas;
            this.data.forEach((grafica) => {
              this.getSemaforosGrafica(grafica);
            });
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.data = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          self.loading = false;
        });
    },
  },
  created() {
    this.getGraficas();
  },
};
</script>
